using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.IO; 

public partial class Excel : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        InsertExcelRow("C:\\Book1.xls");
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        InsertExcelRow07("C:\\Book1.xlsx");
    }
    protected void Button3_Click(object sender, EventArgs e)
    {
        UpdateExcelRow("C:\\Book1.xls");
    }
    protected void Button4_Click(object sender, EventArgs e)
    {
        UpdateExcelRow07("C:\\Book1.xlsx");
    }
        private Boolean InsertExcelRow(String strFilePath) 
        {
        if (!File.Exists(strFilePath)) return false;
        String strExcelConn = "Provider=Microsoft.Jet.OLEDB.4.0;" 
        + "Data Source=" + strFilePath + ";" 
        + "Extended Properties='Excel 8.0;HDR=Yes'"; 
        OleDbConnection connExcel = new OleDbConnection(strExcelConn); 
        OleDbCommand cmdExcel = new OleDbCommand();
        try
        {
            cmdExcel.Connection = connExcel;

            //Check if the Sheet Exists
            connExcel.Open();
            DataTable dtExcelSchema;
            dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
            connExcel.Close();
            DataRow[] dr = dtExcelSchema.Select("TABLE_NAME = 'tblData'");

            //if not Create the Sheet
            if (dr == null || dr.Length == 0)
            {
                cmdExcel.CommandText = "CREATE TABLE [tblData]" +
                 "(ID varchar(10), Name varchar(50));";
                connExcel.Open();
                cmdExcel.ExecuteNonQuery();
                connExcel.Close();
            }

            connExcel.Open();
            
            //Add New Row to Excel File 
            cmdExcel.CommandText = "INSERT INTO [tblData] (ID, Name)" +
           " values ('1', 'MAK')"; 
            cmdExcel.ExecuteNonQuery();
            connExcel.Close();
            return true;
        }
        catch
        {
            return false;
        }
        finally
        {
            cmdExcel.Dispose();
            connExcel.Dispose();
        }
        }

    private Boolean UpdateExcelRow(String strFilePath)
    {
        if (!File.Exists(strFilePath)) return false;
        String strExcelConn = "Provider=Microsoft.Jet.OLEDB.4.0;"
        + "Data Source=" + strFilePath + ";"
        + "Extended Properties='Excel 8.0;HDR=Yes'";
        OleDbConnection connExcel = new OleDbConnection(strExcelConn);
        OleDbCommand cmdExcel = new OleDbCommand();
        try
        {
            cmdExcel.Connection = connExcel;

            //Check if the Sheet Exists
            connExcel.Open();
            DataTable dtExcelSchema;
            dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
            connExcel.Close();
            DataRow[] dr = dtExcelSchema.Select("TABLE_NAME = 'tblData'");

            if (dr != null || dr.Length > 0)
            {
                connExcel.Open();
                cmdExcel.CommandText = "UPDATE [tblData] SET Name = 'John' WHERE ID = '1'";
                cmdExcel.ExecuteNonQuery();
                connExcel.Close();

            }
            return true;
        }
        catch
        {
            return false;
        }
        finally
        {
            cmdExcel.Dispose();
            connExcel.Dispose();
        }
    }

        private Boolean InsertExcelRow07(String strFilePath)
        {
            if (!File.Exists(strFilePath)) return false;
            string strExcelConn = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" 
            + strFilePath + ";Excel 12.0;HDR=YES;";
            OleDbConnection connExcel = new OleDbConnection(strExcelConn);
            OleDbCommand cmdExcel = new OleDbCommand();
            try
            {
                cmdExcel.Connection = connExcel;

                //Check if the Sheet Exists
                connExcel.Open();
                DataTable dtExcelSchema;
                dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
                connExcel.Close();
                DataRow[] dr = dtExcelSchema.Select("TABLE_NAME = 'tblData'");

                //if not Create the Sheet
                if (dr == null || dr.Length == 0)
                {
                    cmdExcel.CommandText = "CREATE TABLE [tblData] (ID varchar(10), Name varchar(50));"; ;
                    connExcel.Open();
                    cmdExcel.ExecuteNonQuery();
                    connExcel.Close();
                }

                //Add New Row to Excel File 
                cmdExcel.CommandText = "INSERT INTO [tblData] (ID, Name)" + "values ('1', 'MAK')";
                connExcel.Open(); 
                cmdExcel.ExecuteNonQuery();
                connExcel.Close();
                return true;
            }
            catch
            {
                return false;
            }
            finally
            {
                cmdExcel.Dispose();
                connExcel.Dispose();
            }
        }

    private Boolean UpdateExcelRow07(String strFilePath)
    {
        if (!File.Exists(strFilePath)) return false;
        string strExcelConn = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source="
        + strFilePath + ";Excel 12.0;HDR=YES;";
        OleDbConnection connExcel = new OleDbConnection(strExcelConn);
        OleDbCommand cmdExcel = new OleDbCommand();
        try
        {
            cmdExcel.Connection = connExcel;

            //Check if the Sheet Exists
            connExcel.Open();
            DataTable dtExcelSchema;
            dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
            connExcel.Close();
            DataRow[] dr = dtExcelSchema.Select("TABLE_NAME = 'tblData'");

            if (dr != null || dr.Length > 0)
            {
                cmdExcel.CommandText = "UPDATE [tblData] SET Name = 'John' WHERE ID = '1'";
                connExcel.Open();
                cmdExcel.ExecuteNonQuery();
                connExcel.Close();
            }

            return true;
        }
        catch
        {
            return false;
        }
        finally
        {
            cmdExcel.Dispose();
            connExcel.Dispose();
        }
    }

}
